# Contributing to express-jsdoc-swagger

Thanks for your interest in express-jsdoc-swagger. Our goal is to provide an easy Swagger OpenAPI 3.x generator using simple JSDoc comments.

## Contributions

express-jsdoc-swagger welcomes contributions from everyone.

Contributions to express-jsdoc-swagger should be made in the form of GitHub pull requests. Each pull request will
be reviewed by a core contributor ([@bri06](https://github.com/bri06) or [@kevinccbsg](https://github.com/kevinccbsg)) and either landed in the
main tree or given feedback for changes that would be required.

## Getting Started

express-jsdoc-swagger's [open issues are here](https://github.com/BRIKEV/express-jsdoc-swagger/issues).

express-jsdoc-swagger's [docs are here](https://brikev.github.io/express-jsdoc-swagger-docs/#/).

You can clone this repository and run this command to start using developing this package.

```
npm install
```

If you want to test it you can add a new test in [this folder](https://github.com/BRIKEV/express-jsdoc-swagger/tree/master/test) or you can create a new example [here](https://github.com/BRIKEV/express-jsdoc-swagger/tree/master/examples).

To execute package's tests you have run this command:

```
npm test
```

Please also ensure linting is correct while you're developing by running this command:

```
npm run lint
```

## Pull Request Checklist

- [Check validations](https://github.com/BRIKEV/express-jsdoc-swagger/actions?query=workflow%3ABuild) should pass. This one includes linting and testing.

- Commits should be as small as possible, while ensuring that each commit is
  correct independently (i.e., each commit should compile and pass tests). 

- If your patch is not getting reviewed or you need a specific person to review
  it, you can @-reply a reviewer asking for a review in the pull request or a
  comment.


## Conduct

We follow the [express-jsdoc-swagger Code of Conduct](https://github.com/BRIKEV/express-jsdoc-swagger/blob/master/CODE_OF_CONDUCT.md).

All code in this repository is under [MIT License](https://github.com/BRIKEV/express-jsdoc-swagger/blob/master/LICENSE.md).
